




















(   // DOUBLE CLICK here, then run the whole process as a 1.do task
(
{1.do{

	o = Server.default.options;
	o.memSize = 130672;
	//o.device = "MOTU UltraLite mk3 Hybrid";
	o.device = "Avid Mbox Mini"; //select audio device
	//o.device = "Scarlett 18i8 USB";



	s.reboot;


	1.wait;




	//4 sines oscilators (synthesizers)
	SynthDef(\osc,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;



	SynthDef(\osc2,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal =env *osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;


	SynthDef(\osc3,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.1

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;


	SynthDef(\osc4,
		{
			arg vol = 0, mul = 0.05, gate = 0, gate2 =0, freq = 100, rate =1; //mul was 0.05

			var osc, out, env, env2, signal;

			osc = SinOsc.ar(freq, 0, (SinOsc.ar(rate) * mul) + vol);

			env = EnvGen.ar(Env.asr(5,1,10), gate, doneAction: 0);

			env2 = EnvGen.ar(Env.asr(3,1,10), gate2, doneAction: 0);

			signal = env * osc * env2;

			out = Out.ar(0, Pan2.ar(signal, SinOsc.ar(Rand(0.01,1))));
		}
	).add;

	//Synthesizer: low freqs (bowed)

	(
		SynthDef(\drone1,{

			arg mix = 1, room = 3, damp = 5, freq = 40, freq2= 30, gate = 1, amp = 0, attackSpeed = 80; //amp was 0.6, now 0, 0.6 in args below

			var verb, duster, filter, env, out;

			duster = Dust.ar(
				attackSpeed,
				1);

			filter = (DynKlank.ar(`[
				Array.series(12, Rand(20,100) , Rand(20, 100)),
				Array.geom(12,1,Rand(0.7,0.9)),
				Array.fill(12, {Rand(1.0,3.0)})
			], duster) * 0.2).softclip;

			verb = FreeVerb.ar(
				filter,
				mix,
				room,
				damp);

			env = EnvGen.ar(Env.asr(Rand(5,8), 0.5, Rand(5,8)), gate, doneAction:2);

			env = env * (verb * amp);

			out = Out.ar(0, env !2);

		}).add;
	);









	//Synthesizer: clicks_1 (Feedback Synth)



	SynthDef(\clicks_1, {

		arg out = 30, in = 30, freq1 = 1600, freq2=635, rate = 1, oscVol =1, vol= 1, feedbackVol =1, gate =1, panRate=0.1, roomSize =100, gate2 =1;

		var sound;
		var oscs;
		var pan;
		var input;
		var filter;
		var comp;
		var env;
		var env2;




		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = (SinOsc.ar((freq1 + freq2 )/2, input) * SinOsc.ar([freq1, freq2], input, Dust.kr(rate).max(0) * oscVol))/*.fold2(Line.kr(0,1.01,8))*/;

		sound = GVerb.ar(oscs,roomSize, 5, 0.1);


		pan = Pan2.ar(sound, SinOsc.ar(panRate));


		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		filter = BPF.ar(pan, (freq1+freq2));

		comp = Compander.ar(filter, 0, 0.1, clampTime: 0.0001);


		Out.ar(out, Limiter.ar(comp *vol *env* env2 * 1, 0.9)); //* previously 2 in the amp, now 1


	}).send;


	//bus/synth required for feedback
	SynthDef("bus_stereo_1", { arg out=0, in=30;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_1 = Synth("bus_stereo_1"); //execute first and let running
	//~clicks_1 = Synth(\clicks_1);




	// Synthesizer: clicks_2 (Feedback synth)

	SynthDef(\clicks_2, {

		arg out = 32, in = 32, freq = 1300, rate = 1, oscVol =1, vol= 1, feedbackVol =1, gate =1, panRate=0.1, roomSize =100, gate2=1;

		var sound;
		var oscs;
		var pan;
		var input;
		var filter;
		var comp;
		var env;
		var env2;



		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = SinOsc.ar(freq, input, Dust.kr(rate).max(0) * 0.8).fold2(Line.kr(0,1.01,8));

		sound = GVerb.ar(oscs,roomSize, 5, 0.1);

		pan = Pan2.ar(sound, SinOsc.ar(panRate));

		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		filter = BPF.ar(pan, freq);

		comp = Compander.ar(filter, 0, 0.1, clampTime: 0.0001);


		Out.ar(out, Limiter.ar(comp *vol *env* env2* 1, 0.9)); //* previously 2 in the amp, now 1

	}).add;

	//bus/synth required for feedback
	SynthDef("bus_stereo_2", { arg out=0, in=32;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_2 = Synth("bus_stereo_2"); //execute first and let running
	//~clicks_2= Synth(\clicks_2);








	//Synthesizer: clicks_3 (Feedback synth)



	SynthDef(\clicks_3, { arg out=34, in=34, freq =1300, rate =1, vol=0.09, feedbackVol =24, gate =1, panRate=0.1, gate2 =1;
		var input, sound, env, env2;
		input = InFeedback.ar(in, 1) * feedbackVol;
		sound = GVerb.ar(Pan2.ar(SinOsc.ar(freq, input, LFNoise2.ar(rate)).fold2(Line.kr(0,1.01,8)),SinOsc.ar(panRate)), 100, 5, 0.1);
		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;
		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ;

		Out.ar(out, Limiter.ar(sound *vol *env * env2, 0.9)); //vol was 0.05 then 0.1 then 0.08, now 0.09

	}).add;

	//bus/synth required for feedback
	SynthDef("bus_stereo_3", { arg out=0, in=34;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;


	//
	//~bus_clicks_3 = Synth("bus_stereo_3"); //execute first and let running
	//~clicks_3 = Synth(\clicks_3);







	//Synthesizer: clicks_4 (Feedback synth)



	SynthDef(\clicks_4, { ////// old \sound3

		arg out=36, in=36, freq1 = 1600, freq2=635, rate =1, vol=0.09, feedbackVol =1, gate =1, panRate=0.1, gate2 =1;

		var sound;
		var oscs;
		var pan;
		var input;
		var env;
		var env2;




		input = InFeedback.ar(in, 1) * feedbackVol;

		oscs = SinOsc.ar((freq1 + freq2 )/2, input) * SinOsc.ar([freq1, freq2], input, LFNoise2.ar(rate))/*.fold2(Line.kr(0,1.01,8))*/;

		sound = GVerb.ar(oscs,100, 5, 0.1);


		pan = Pan2.ar(sound, SinOsc.ar(panRate));


		env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

		env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2, doneAction:2) ; //vol was 0.05 then 0.1 then 0.08 now 0.09



		//SendReply.kr(Impulse.kr(200), '/amp', Amplitude.kr(comp)); //send data from server
		Out.ar(out, Limiter.ar(pan *vol *env* env2, 0.9));


	}).send;


	//bus/synth required for feedback
	SynthDef("bus_stereo_4", { arg out=0, in=36;

		var signal;

		signal = In.ar([in, in+1]);

		Out.ar(out, signal);

	}).add;




//===========Set buses synths

~bus_clicks_1 = Synth("bus_stereo_1"); //execute first and let running
~bus_clicks_2 = Synth("bus_stereo_2");//execute first and let running
~bus_clicks_3 = Synth("bus_stereo_3"); //execute first and let running
~bus_clicks_4 = Synth("bus_stereo_4"); //execute first and let running








	//========Set sines synths


	0.5.wait;


	~osc = Synth(\osc, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;



	~osc2 = Synth(\osc2, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc2.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc2.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;



	~osc3 = Synth(\osc3, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);




	{inf.do({

		~osc3.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc3.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;


	});
	}.fork;




	~osc4 = Synth(\osc4, [\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1]);


	{inf.do({

		~osc4.set(\gate2, 0);

		rrand(10, 20).wait;

		~osc4.set(\freq, exprand(80, 5000), \rate, rrand(0.01, 10), \gate2, 1);

		rrand(10, 50).wait;




	});
	}.fork;




	//================play/stop sounds


	0.5.wait;

	//play sines
	~osc.set(\gate, 1 );
	~osc2.set(\gate, 1 );
	~osc3.set(\gate, 1 );
	~osc4.set(\gate, 1 );

	//play drones

	~dronesRoutine = 	Routine({ loop{

		~drone = Synth(\drone1, [\attackSpeed, rrand(0.5, 40).postln, \amp, 0.6]);

		rrand(3, 15).wait;


		~drone.set(\gate, 0);

		rrand(3, 8).wait;}
	});
	~dronesRoutine.play;





}}.fork;






);





(



// ---------- Tasks for parameters randomisation


~task1= Task({

	loop{

		~clicks_1A = Synth(\clicks_1);
		rrand(0.1, 2).wait;
		~clicks_1A.set(\feedbackVol, rrand(1, 120).postln);
		~clicks_1A.set(\roomSize, rrand(20, 100).postln);
		~clicks_1A.set(\freq1, exprand(20, 5000).postln);
		~clicks_1A.set(\freq2, exprand(20, 5000).postln);
		~clicks_1A.set(\rate, rrand(0.1, 0.5).postln);

		rrand(10, 30).wait;
		~clicks_1A.set(\gate2, 0);
		rrand(10, 50).wait;

	}
});

//
~task1.start;

//
// ~task1.stop;
// ~clicks_1A.set(\gate, 0);
//


//



~task2= Task({

	loop{

		~clicks_2A = Synth(\clicks_1);
		rrand(0.1, 2).wait;

		~clicks_2A.set(\feedbackVol, rrand(1, 200).postln);
		~clicks_2A.set(\roomSize, rrand(1, 5).postln);
		~clicks_2A.set(\freq, exprand(20, 5000).postln);
		~clicks_2A.set(\rate, rrand(0.1, 0.5).postln);

		rrand(10, 30).wait;
		~clicks_2A.set(\gate2, 0);
		rrand(10, 50).wait;

	}
});

//
~task2.start;

//
// ~task2.stop;
// ~clicks_2A.set(\gate, 0);
//


//-------------------








//


~task3= Task({

	loop{


		rrand(2, 10).wait;

		~clicks_1 = Synth(\clicks_1, [\gate2, 1]);
		rrand(0.1, 2).wait;

		~clicks_1.set(\feedbackVol, rrand(1, 120).postln);
		~clicks_1.set(\roomSize, rrand(20, 100).postln);
		~clicks_1.set(\freq1, exprand(20, 5000).postln);
		~clicks_1.set(\freq2, exprand(20, 5000).postln);
		~clicks_1.set(\rate, rrand(0.1, 0.5).postln);

		rrand(2, 30).wait;

		~clicks_1.set(\gate2,0);
		rrand(10, 30).wait;

	}
});

//
~task3.start;

//
// ~task3.stop;
// ~clicks_1.set(\gate, 0);
//




//



~task4= Task({

	loop{

		rrand(2, 10).wait;

		~clicks_2= Synth(\clicks_2, [\gate2, 1]);

		rrand(0.1, 2).wait;

		~clicks_2.set(\feedbackVol, rrand(1, 200).postln);
		~clicks_2.set(\roomSize, rrand(1, 5).postln);
		~clicks_2.set(\freq, exprand(20, 5000).postln);
		~clicks_2.set(\freq2, exprand(20, 5000).postln);
		~clicks_2.set(\rate, rrand(0.1, 0.5).postln);


		rrand(2, 30).wait;

		~clicks_2.set(\gate2,0);
		rrand(10, 30).wait;


	}
});

//
~task4.start;

//
// ~task4.stop;
// ~clicks_2.set(\gate, 0);
//



//--------------------







~task5= Task({

	loop{



	rrand(2, 10).wait;

	~clicks_3 = Synth(\clicks_3, [\gate2, 1,\freq, exprand(20, 5000), \rate, rrand(1.0, 3.0), \panRate, rrand(0.01,4),\feedbackVol, rrand(16, 20)]);

	rrand(2, 20).wait;

	~clicks_3.set(\gate2,0);
	rrand(10, 100).wait;

	}
});

~task5.start;

//
// ~task5.stop;
// ~clicks_3.set(\gate, 0);
//




//






~task6= Task({

	loop{


	rrand(2, 10).wait;

	~clicks_4 = Synth(\clicks_4, [\gate2, 1, \freq1, exprand(20, 5000), \freq2, exprand(20, 5000), \rate, rrand(1.0, 5.0),\panRate, rrand(0.01,10), \feedbackVol, rrand(3, 6)]);


	rrand(2, 20).wait;

	~clicks_4.set(\gate2,0);
	rrand(10, 100).wait;

	}
});

~task6.start;

//
// ~task6.stop;
// ~clicks_4.set(\gate, 0);
//



/*
~finalTask = Task({
	loop{
		(
			a=[1,2,3,4].choose;

			if(a==1, {~task1.start; "task1".postln;
				~task2.stop;  ~clicks_2A.set(\gate, 0);
				~task3.stop; ~clicks_1.set(\gate, 0);
				~task4.stop; ~clicks_2.set(\gate, 0);});

			if(a==2, {~taks2.start; "task2".postln;
				~task1.stop; ~clicks_1A.set(\gate, 0);
				~task3.stop; ~clicks_1.set(\gate, 0);
				~task4.stop; ~clicks_2.set(\gate, 0);});

			if(a==3, {~task3.start; "task3".postln;
				~task1.stop; ~clicks_1A.set(\gate, 0);
				~task2.stop; ~clicks_2A.set(\gate, 0);
				~task4.stop; ~clicks_2.set(\gate, 0);});


			if(a==4, {~task4.start; "task4".postln;
				~task1.stop; ~clicks_1A.set(\gate, 0);
				~task2.stop; ~clicks_2A.set(\gate, 0);
				~task3.stop; ~clicks_1.set(\gate, 0); });

		);
		10.wait;
		"newTask".postln;
	}
});

~finalTask.start;*/

//~finalTask.stop;



//---------------------










/*{inf.do{


~drone.set(\gate, 0);
~dronesRoutine.stop;
~drone.set(\gate, 0);



~osc.set(\gate, 0 );
0.2.wait;
~osc2.set(\gate, 0 );
0.3.wait;
~osc3.set(\gate, 0 );
0.4.wait;
~osc4.set(\gate, 0 );

~clicks1.set(\gate2,0);
~clicks1A.set(\gate2,0);
~clicks_2.set(\gate2,0);
~clicks_2A.set(\gate2,0);
~clicks_3.set(\gate2,0);
~clicks_4.set(\gate2,0);
~vocalFeedback.set(\gate2,0);


"stop Audio and wait".postln;
//wait in silence

rrand(60, 180).wait;
//30.wait;



}}.fork;
*/



);
);