//Audio Source

( // DOUBLE CLICK here, then run the code
s.boot;

~source=0;

);

( // DOUBLE CLICK here, then run the code




//Audio Feedback Synth
SynthDef(\vocalFeedback, { arg freq1 = 1600, pitchRatio= 2, in = 34, gate =1, gate2 =1, roomsize =100, revtime=105, vol =0.8;

	var sound;
	var input;

	var env;

	var env2;

	input =InFeedback.ar(in, 1);

	sound = GVerb.ar(PitchShift.ar(SoundIn.ar(~source),0.1, pitchRatio) * SinOsc.ar((freq1 + Pitch.kr(SoundIn.ar(~source) ))/2, PitchShift.ar(input, 0.2,pitchRatio) ),roomsize, revtime, 0.1);

	env =EnvGen.ar(Env.asr(5, 1, 5),gate) ;

	env2 =EnvGen.ar(Env.asr(10, 1, 10),gate2) ;

	Out.ar(0, Limiter.ar(sound* env* env2 * vol, 0.7));

}).add;


//Play Synth
~vocalFeedback =Synth(\vocalFeedback);
//
//
//
//Possible variation on parameters
~vocalFeedback.set(\freq1, exprand(50, 5000).postln);
~vocalFeedback.set(\vol, 0.2.postln);
~vocalFeedback.set(\pitchRatio, 4);
// ~vocalFeedback.set(\revtime, exprand(90, 100).postln);



//plain vocal amplification synth
SynthDef(\Voice, {

 Out.ar(0, SoundIn.ar(~source, 1) ! 2);

}
).add;


//
//~voice = Synth(\VoiceAmped);




//===========================






//Granular Synth I
SynthDef(\grain,{

	arg vol = 0.3, gate = 1, ratio = 4, timeDispersion = 10, revtime =10, roomsize =105;

	var overallVerb, pitchShift, inerVerb, env, out;


	inerVerb =	GVerb.ar(SoundIn.ar(0), roomsize, revtime, 0.8, spread: 30, taillevel: 1);

	pitchShift =  PitchShift.ar(inerVerb, 0.1, ratio, 1, timeDispersion: timeDispersion);

	overallVerb = GVerb.ar(pitchShift);

	env = EnvGen.ar(Env.asr(4, 1, 10), gate, doneAction:2);

	env = env * overallVerb;

	out = Out.ar(0, Limiter.ar(env * vol,0.7) );


}).add;




//* env slider
//Make two instances, each one controled by a different finger!
//
// ~grain = Synth(\grain);
//
// ~grain.set(\vol, 0.3);
// ~grain.set(\ratio, 4); //2-4
// ~grain.set(\revtime, 1); //1-100
// ~grain.free;

//c = Synth(\grain);
//ratio = 0 - 4




//Granular Synth II

SynthDef(\grain2,{

	arg vol = 1, gate = 1, ratio = 4, timeDispersion = 1, revtime =1, roomsize =15;

	var overallVerb, pitchShift, inerVerb, env, out;


	inerVerb =	GVerb.ar(SoundIn.ar(0), roomsize, revtime, 0.8, spread: 10, taillevel: 1);

	pitchShift =  PitchShift.ar(inerVerb, 0.1, ratio, 1, timeDispersion: timeDispersion)* EnvGen.ar(Env.perc(0.001,0.001,1,-4),Dust.ar(100));

	overallVerb = GVerb.ar(pitchShift);

	env = EnvGen.ar(Env.asr(4, 1, 10), gate, doneAction:2);

	env = env * overallVerb;

	out = Out.ar(0, Limiter.ar(env * vol,0.7) );


}).add;

 ~grain2 = Synth(\grain2);
~grain2.set(\ratio, 4); //2-4
 ~grain2.set(\revtime, 1); //1-100
 ~grain2.set(\vol, 1);

//play with dust 50-100, vol: 0.1-1

);



